Index: src/settings.cpp
===================================================================
--- src/settings.cpp	(revision 13683)
+++ src/settings.cpp	(working copy)
@@ -63,8 +63,12 @@
 #include "gamelog.h"
 #include "station_func.h"
 
+#include "sharedinfrastructure.h"
+
 #include "table/strings.h"
 
+#include "core/smallvec_type.hpp"
+
 ClientSettings _settings_client;
 GameSettings _settings_game;
 GameSettings _settings_newgame;
@@ -1462,6 +1466,7 @@
 	if (strcmp(_settings_client.network.rcon_password, "*") == 0) {
 		_settings_client.network.rcon_password[0] = '\0';
 	}
+	InvalidateWindow(WC_GAME_OPTIONS, 0);
 
 	return 0;
 }
@@ -1657,6 +1662,7 @@
 	SDT_CONDBOOL(GameSettings, construction.road_stop_on_town_road,             47, SL_MAX_VERSION, 0, 0,  true,                    STR_CONFIG_PATCHES_STOP_ON_TOWN_ROAD,      NULL),
 	SDT_CONDBOOL(GameSettings, station.adjacent_stations,                       62, SL_MAX_VERSION, 0, 0,  true,                    STR_CONFIG_PATCHES_ADJACENT_STATIONS,      NULL),
 	SDT_CONDBOOL(GameSettings, economy.station_noise_level,                     96, SL_MAX_VERSION, 0, 0, false,                    STR_CONFIG_PATCHES_NOISE_LEVEL,            InvalidateTownViewWindow),
+	SDT_CONDBOOL(GameSettings, construction.one_tile_terraform,					 SL_VERSION_PATCH, SL_MAX_VERSION, 0, 0, false,					STR_CONFIG_PATCHES_ONE_TILE_TERRAFORM,	   NULL),
 
 	    SDT_BOOL(GameSettings, economy.inflation,                                                   0, 0,  true,                    STR_CONFIG_PATCHES_INFLATION,              NULL),
 	     SDT_VAR(GameSettings, construction.raw_industry_construction, SLE_UINT8,                   0,MS,     0,     0,       2, 0, STR_CONFIG_PATCHES_RAW_INDUSTRY_CONSTRUCTION_METHOD, InvalidateBuildIndustryWindow),
@@ -1744,10 +1750,33 @@
 	     SDT_VAR(GameSettings, game_creation.map_x,                           SLE_UINT8,                     S, 0,     8,                     6,      11, 0, STR_CONFIG_PATCHES_MAP_X,                 NULL),
 	     SDT_VAR(GameSettings, game_creation.map_y,                           SLE_UINT8,                     S, 0,     8,                     6,      11, 0, STR_CONFIG_PATCHES_MAP_Y,                 NULL),
 
+	SDT_CONDBOOL(GameSettings, construction.disable_tree_growth,			SL_VERSION_PATCH, SL_MAX_VERSION, 0, 0, false,					STR_CONFIG_PATCHES_TREE_GROWTH,            NULL),
+
+
  SDT_CONDOMANY(GameSettings, locale.currency,                               SLE_UINT8, 97, SL_MAX_VERSION, N, 0, 0, CUSTOM_CURRENCY_ID, "GBP|USD|EUR|YEN|ATS|BEF|CHF|CZK|DEM|DKK|ESP|FIM|FRF|GRD|HUF|ISK|ITL|NLG|NOK|PLN|ROL|RUR|SIT|SEK|YTL|SKK|BRR|custom", STR_NULL, NULL, NULL),
  SDT_CONDOMANY(GameSettings, locale.units,                                  SLE_UINT8, 97, SL_MAX_VERSION, N, 0, 1, 2, "imperial|metric|si", STR_NULL, NULL, NULL),
 
+
 	/***************************************************************************/
+	/* Shared Infrastructure configure patches window */
+	SDT_CONDBOOL(GameSettings, sharing.shared_railway_stations,         SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_RAILWAY_STATIONS, SettingsEnableSharedRailwayStations),
+	SDT_CONDBOOL(GameSettings, sharing.shared_railway_tracks,           SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_RAILWAY_TRACKS, SettingsEnableSharedRailwayTracks),
+	SDT_CONDBOOL(GameSettings, sharing.shared_railway_depots,           SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_RAILWAY_DEPOTS, SettingsEnableSharedRailwayStations),
+	SDT_CONDBOOL(GameSettings, sharing.shared_road_depots,              SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_ROAD_DEPOTS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_road_stops,               SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_ROAD_STOPS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_water_depots,             SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_WATER_DEPOTS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_harbours,                 SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_HARBOURS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_airports,                 SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_AIRPORTS, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_provision, SLE_UINT8,     SL_VERSION_PATCH,SL_MAX_VERSION,   0, 0,  10,  0,  100,  5, STR_CONFIG_PATCHES_SHARED_PROVISION, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_tontile_cost, SLE_UINT16, SL_VERSION_PATCH,SL_MAX_VERSION,   0, CR, 30,  0,  250,  5, STR_CONFIG_PATCHES_SHARED_TONTILE_COST, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_landing_fee, SLE_UINT16,  SL_VERSION_PATCH,SL_MAX_VERSION,   0, CR, 50,  0, 1000, 20, STR_CONFIG_PATCHES_SHARED_LANDING_FEE, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_road_stops_fee, SLE_UINT8,SL_VERSION_PATCH,SL_MAX_VERSION,  0, CR,  5,  0,   50,  1, STR_CONFIG_PATCHES_SHARED_ROAD_STOPS_FEE, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_harbours_fee,  SLE_UINT8, SL_VERSION_PATCH,SL_MAX_VERSION,   0, CR, 10,  0,  200,  5, STR_CONFIG_PATCHES_SHARED_HARBOURS_FEE, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_player_level,             SL_VERSION_PATCH,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_PLAYER_LEVEL, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_delay, SLE_UINT8,         SL_VERSION_PATCH,SL_MAX_VERSION,   0, 0,  6,   0,   60,  1, STR_CONFIG_PATCHES_SHARED_DELAY, NULL),
+
+
+	/***************************************************************************/
 	/* Unsaved patch variables. */
 	SDTC_OMANY(gui.autosave,                  SLE_UINT8, S,  0, 1, 4, "off|monthly|quarterly|half year|yearly", STR_NULL,                     NULL),
 	 SDTC_BOOL(gui.vehicle_speed,                        S,  0,  true,                        STR_CONFIG_PATCHES_VEHICLESPEED,                NULL),
@@ -1769,6 +1798,7 @@
 	 SDTC_BOOL(gui.pause_on_newgame,                     S,  0, false,                        STR_CONFIG_PATCHES_PAUSE_ON_NEW_GAME,           NULL),
 	  SDTC_VAR(gui.advanced_vehicle_list,     SLE_UINT8, S, MS,     1,        0,        2, 0, STR_CONFIG_PATCHES_ADVANCED_VEHICLE_LISTS,      NULL),
 	 SDTC_BOOL(gui.timetable_in_ticks,                   S,  0, false,                        STR_CONFIG_PATCHES_TIMETABLE_IN_TICKS,          NULL),
+	 SDTC_BOOL(gui.quick_goto,                           S,  0,  true,                        STR_CONFIG_PATCHES_QUICKGOTO,                   NULL),
 	  SDTC_VAR(gui.loading_indicators,        SLE_UINT8, S, MS,     1,        0,        2, 0, STR_CONFIG_PATCHES_LOADING_INDICATORS,          RedrawScreen),
 	  SDTC_VAR(gui.default_rail_type,         SLE_UINT8, S, MS,     4,        0,        6, 0, STR_CONFIG_PATCHES_DEFAULT_RAIL_TYPE,           NULL),
 	 SDTC_BOOL(gui.enable_signal_gui,                    S,  0, false,                        STR_CONFIG_PATCHES_ENABLE_SIGNAL_GUI,           CloseSignalGUI),
@@ -1819,6 +1849,9 @@
 	  SDTC_VAR(network.last_port,            SLE_UINT16, S,  0,     0,     0,  UINT16_MAX, 0, STR_NULL,                                       NULL),
 #endif /* ENABLE_NETWORK */
 
+	// allowed terraform bitmask, serverside, nosave
+	 SDT_VAR(GameSettings, construction.allow_terraform, SLE_UINT16, S, 0, 65535,     0,    65535, 0, STR_NULL,                                       NULL),
+
 	/*
 	 * Since the network code (CmdChangePatchSetting and friends) use the index in this array to decide
 	 * which patch the server is talking about all conditional compilation of this array must be at the
@@ -1830,7 +1863,6 @@
 	/* We might need to emulate a right mouse button on mac */
 	 SDTC_VAR(gui.right_mouse_btn_emulation, SLE_UINT8, S, MS, 0, 0, 2, 0, STR_CONFIG_PATCHES_RIGHT_MOUSE_BTN_EMU, NULL),
 #endif
-
 	SDT_END()
 };
 
@@ -2101,6 +2133,54 @@
 	ini_free(ini);
 }
 
+typedef SmallVector<char *, 8> PresetList;
+PresetList _grf_preset_list;
+
+void GetGRFPresetList()
+{
+	/* Clear out the list of old entries */
+	for (uint i = 0; i < _grf_preset_list.Length(); i++) {
+		free(_grf_preset_list[i]);
+	}
+
+	_grf_preset_list.Clear();
+
+	IniFile *ini = ini_load(_config_file);
+	IniGroup *group;
+	for (group = ini->group; group != NULL; group = group->next) {
+		if (strncmp(group->name, "preset-", 7) == 0) {
+			*_grf_preset_list.Append() = strdup(group->name + 7);
+		}
+	}
+
+	_grf_preset_list.Compact();
+
+	ini_free(ini);
+}
+
+GRFConfig *LoadGRFPresetFromConfig(const char *config_name)
+{
+	char section[MAX_PATH];
+	snprintf(section, lengthof(section), "preset-%s", config_name);
+
+	IniFile *ini = ini_load(_config_file);
+	GRFConfig *config = GRFLoadConfig(ini, section, false);
+	ini_free(ini);
+
+	return config;
+}
+
+void SaveGRFPresetToConfig(const char *config_name, GRFConfig *config)
+{
+	char section[MAX_PATH];
+	snprintf(section, lengthof(section), "preset-%s", config_name);
+
+	IniFile *ini = ini_load(_config_file);
+	GRFSaveConfig(ini, section, config);
+	ini_save(_config_file, ini);
+	ini_free(ini);
+}
+
 static const SettingDesc *GetSettingDescription(uint index)
 {
 	if (index >= lengthof(_patch_settings)) return NULL;
@@ -2181,6 +2261,11 @@
 	if (!_networking || (_networking && _network_server)) {
 		return DoCommandP(0, index, value, NULL, CMD_CHANGE_PATCH_SETTING);
 	}
+	if (_networking && !_network_server && _settings_client.network.rcon_password[0] != '\0') {
+		char patch_rcon_command[70];
+		sprintf(patch_rcon_command, "patch %s %d", _patch_settings[index].desc.name, value);
+		NetworkClientSendRcon(_settings_client.network.rcon_password, patch_rcon_command);
+	}
 	return false;
 }
 
Index: src/bridge_gui.cpp
===================================================================
--- src/bridge_gui.cpp	(revision 13683)
+++ src/bridge_gui.cpp	(working copy)
@@ -287,6 +287,16 @@
 	 *      7..0 = type of bridge */
 	uint32 type = (transport_type << 15) | (bridge_type << 8);
 
+	/* When Ctrl is beeing pressed, just build the fastest available bridge and return */
+	if (_ctrl_pressed) {
+		BridgeType fastest_type = GetFastestAvailableBridgeType(GetTunnelBridgeLength(end, start));
+		if (fastest_type < MAX_BRIDGES)
+			DoCommandP(end, start,
+				type | fastest_type, CcBuildBridge,
+				CMD_BUILD_BRIDGE | CMD_MSG(STR_5015_CAN_T_BUILD_BRIDGE_HERE));
+		return;
+	}
+
 	/* only query bridge building possibility once, result is the same for all bridges!
 	 * returns CMD_ERROR on failure, and price on success */
 	StringID errmsg = INVALID_STRING_ID;
Index: src/toolbar_gui.cpp
===================================================================
--- src/toolbar_gui.cpp	(revision 13683)
+++ src/toolbar_gui.cpp	(working copy)
@@ -41,6 +41,7 @@
 
 #include "network/network.h"
 #include "network/network_gui.h"
+#include "network/network_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -184,8 +185,13 @@
 
 static void ToolbarPauseClick(Window *w)
 {
-	if (_networking && !_network_server) return; // only server can pause the game
-
+	if (!(_networking && (_network_server || _settings_client.network.rcon_password[0] != '\0'))) return; // you can only pause the game if you have the rcon password or are the server
+	if (_networking && !_network_server && _settings_client.network.rcon_password[0] != '\0') {
+		NetworkClientSendRcon(_settings_client.network.rcon_password, (_pause_game ? "unpause" : "pause"));
+		SndPlayFx(SND_15_BEEP);
+	}
+	
+	if (_networking && !_network_server) return; // only server can pause the game using this command
 	if (DoCommandP(0, _pause_game ? 0 : 1, 0, NULL, CMD_PAUSE)) SndPlayFx(SND_15_BEEP);
 }
 
@@ -884,7 +890,6 @@
 struct MainToolbarWindow : Window {
 	MainToolbarWindow(const WindowDesc *desc) : Window(desc)
 	{
-		this->SetWidgetDisabledState(TBN_PAUSE, _networking && !_network_server); // if not server, disable pause button
 		this->SetWidgetDisabledState(TBN_FASTFORWARD, _networking); // if networking, disable fast-forward button
 
 		CLRBITS(this->flags4, WF_WHITE_BORDER_MASK);
@@ -900,6 +905,7 @@
 		GfxFillRect(0, 0, this->width - 1, this->height - 1, 0xB2);
 		GfxFillRect(0, 0, this->width - 1, this->height - 1, 0xB4, FILLRECT_CHECKER);
 
+		this->SetWidgetDisabledState(TBN_PAUSE, !(_networking && (_network_server || _settings_client.network.rcon_password[0] != '\0'))); // if not server, disable pause button
 		/* If spectator, disable all construction buttons
 		* ie : Build road, rail, ships, airports and landscaping
 		* Since enabled state is the default, just disable when needed */
Index: src/depot_base.h
===================================================================
--- src/depot_base.h	(revision 13683)
+++ src/depot_base.h	(working copy)
@@ -27,6 +27,8 @@
 	return index < GetDepotPoolSize() && GetDepot(index)->IsValid();
 }
 
+static const DepotID INVALID_DEPOT = 0xFFFF;
+
 Depot *GetDepotByTile(TileIndex tile);
 
 #define FOR_ALL_DEPOTS_FROM(d, start) for (d = GetDepot(start); d != NULL; d = (d->index + 1U < GetDepotPoolSize()) ? GetDepot(d->index + 1U) : NULL) if (d->IsValid())
Index: src/tile_cmd.h
===================================================================
--- src/tile_cmd.h	(revision 13683)
+++ src/tile_cmd.h	(working copy)
@@ -52,6 +52,8 @@
 	Owner owner[4];
 	StringID owner_type[4];
 	Date build_date;
+	StringID grfclass;
+	StringID grfname;
 	uint64 dparam[2];
 };
 
Index: src/settings_gui.cpp
===================================================================
--- src/settings_gui.cpp	(revision 13683)
+++ src/settings_gui.cpp	(working copy)
@@ -611,6 +611,7 @@
 	"gui.advanced_vehicle_list",
 	"gui.loading_indicators",
 	"gui.timetable_in_ticks",
+	"gui.quick_goto",
 	"gui.default_rail_type",
 	"gui.always_build_infrastructure",
 };
@@ -626,6 +627,8 @@
 	"gui.drag_signals_density",
 	"game_creation.oil_refinery_limit",
 	"gui.semaphore_build_before",
+	"construction.disable_tree_growth",
+	"construction.one_tile_terraform",
 };
 
 static const char *_patches_stations[] = {
@@ -705,6 +708,24 @@
 	"vehicle.dynamic_engines",
 };
 
+static const char *_patches_shared_infrastructure[] = {
+		"shared_railway_stations",
+		"shared_railway_tracks",
+		"shared_railway_depots",
+		"shared_road_stops",
+		"shared_road_depots",
+		"shared_harbours",
+		"shared_water_depots",
+		"shared_airports",
+		"shared_provision",
+		"shared_tontile_cost",
+		"shared_landing_fee",
+		"shared_road_stops_fee",
+		"shared_harbours_fee",
+		"shared_player_level",
+		"shared_delay",
+};
+
 struct PatchEntry {
 	const SettingDesc *setting;
 	uint index;
@@ -726,6 +747,7 @@
 	{_patches_stations,     NULL, lengthof(_patches_stations)},
 	{_patches_economy,      NULL, lengthof(_patches_economy)},
 	{_patches_ai,           NULL, lengthof(_patches_ai)},
+	{_patches_shared_infrastructure, NULL, lengthof(_patches_shared_infrastructure)},
 };
 
 enum PatchesSelectionWidgets {
@@ -735,7 +757,8 @@
 	PATCHSEL_VEHICLES,
 	PATCHSEL_STATIONS,
 	PATCHSEL_ECONOMY,
-	PATCHSEL_COMPETITORS
+	PATCHSEL_COMPETITORS,
+	PATCHSEL_SHARING
 };
 
 struct PatchesSelectionWindow : Window {
@@ -803,7 +826,11 @@
 			bool disabled = false;
 
 			// We do not allow changes of some items when we are a client in a networkgame
-			if (!(sd->save.conv & SLF_NETWORK_NO) && _networking && !_network_server) editable = false;
+			if (!(sd->save.conv & SLF_NETWORK_NO) && _networking && !_network_server) {
+					if (!_network_server && _settings_client.network.rcon_password[0] == '\0') {
+						editable = false;
+					}
+				}
 			if ((sdb->flags & SGF_NETWORK_ONLY) && !_networking) editable = false;
 			if ((sdb->flags & SGF_NO_NETWORK) && _networking) editable = false;
 
@@ -865,7 +892,12 @@
 				sd = page->entries[btn].setting;
 
 				/* return if action is only active in network, or only settable by server */
-				if (!(sd->save.conv & SLF_NETWORK_NO) && _networking && !_network_server) return;
+				if (!(sd->save.conv & SLF_NETWORK_NO) && _networking && !_network_server) {
+					if (!_network_server && _settings_client.network.rcon_password[0] == '\0') {
+						return;
+					}
+				}
+
 				if ((sd->desc.flags & SGF_NETWORK_ONLY) && !_networking) return;
 				if ((sd->desc.flags & SGF_NO_NETWORK) && _networking) return;
 
@@ -931,6 +963,7 @@
 
 			case PATCHSEL_INTERFACE: case PATCHSEL_CONSTRUCTION: case PATCHSEL_VEHICLES:
 			case PATCHSEL_STATIONS:  case PATCHSEL_ECONOMY:      case PATCHSEL_COMPETITORS:
+			case PATCHSEL_SHARING:
 				this->RaiseWidget(this->page + PATCHSEL_INTERFACE);
 				this->page = widget - PATCHSEL_INTERFACE;
 				this->LowerWidget(this->page + PATCHSEL_INTERFACE);
@@ -977,6 +1010,7 @@
 {    WWT_TEXTBTN,   RESIZE_NONE,     3,   271,   357,    16,    27, STR_CONFIG_PATCHES_STATIONS,     STR_NULL},
 {    WWT_TEXTBTN,   RESIZE_NONE,     3,    10,    96,    28,    39, STR_CONFIG_PATCHES_ECONOMY,      STR_NULL},
 {    WWT_TEXTBTN,   RESIZE_NONE,     3,    97,   183,    28,    39, STR_CONFIG_PATCHES_AI,           STR_NULL},
+{    WWT_TEXTBTN,   RESIZE_NONE,     3,   184,   270,    28,    39, STR_CONFIG_PATCHES_SHARED,       STR_NULL},
 {   WIDGETS_END},
 };
 
Index: src/console_cmds.cpp
===================================================================
--- src/console_cmds.cpp	(revision 13683)
+++ src/console_cmds.cpp	(working copy)
@@ -119,6 +119,18 @@
 	return true;
 }
 
+DEF_CONSOLE_CMD(ConResetEconomy)
+{
+	if (argc == 0) {
+		IConsoleHelp("Reset cargo payment rates and prices. It might solve issues with unpaid cargo transports. Usage: 'reseteconomy'");
+		return true;
+	}
+
+	StartupEconomy();
+	InitializeLandscapeVariables(false);
+	return true;
+}
+
 #ifdef _DEBUG
 DEF_CONSOLE_CMD(ConResetTile)
 {
@@ -592,6 +604,48 @@
 	return true;
 }
 
+DEF_CONSOLE_CMD(ConMoveClient)
+{
+	NetworkClientInfo *ci;
+	uint16 index;
+	PlayerID new_player;
+
+	if (argc < 2) {
+		IConsoleHelp("Move a player to another company. Usage: move <client-id> [<company-id>]");
+		IConsoleHelp("For client-id see 'clients', company-id must be between 1 and 8, ommit if moving to spectators");
+		return true;
+	}
+
+	index = atoi(argv[1]);
+	new_player = (argc == 3) ? (PlayerID)(atoi(argv[2])-1) : PLAYER_SPECTATOR; 
+	
+	if (index == NETWORK_SERVER_INDEX) {
+		IConsoleError("Silly boy, you can not move the server!");
+		return true;
+	}
+
+	ci = NetworkFindClientInfoFromIndex(index);
+	if (ci == NULL) {
+		IConsoleError("Invalid client");
+		return true;
+	}
+
+	if (!IsValidPlayer(new_player) && new_player != PLAYER_SPECTATOR) {
+		IConsoleError("Company does not exist, see command 'players'.");
+		return true;
+	}
+
+	/* safe to update, update first the actual client, then all clients */
+	ci->client_playas = new_player;
+	NetworkServerSendMove(index, new_player);
+	NetworkUpdateClientInfo(index);
+
+	IConsolePrintF(CC_DEFAULT, "[move] client %d to company %d.", index, min(new_player+1, PLAYER_SPECTATOR));
+	if (!_network_dedicated) InvalidateWindow(WC_MOVE_PLAYER, 0);
+	if (!_network_dedicated) InvalidateWindow(WC_CLIENT_LIST, 0);
+	return true;
+}
+
 DEF_CONSOLE_CMD(ConResetCompany)
 {
 	const Player *p;
@@ -707,6 +761,49 @@
 	return true;
 }
 
+DEF_CONSOLE_CMD(ConMute)
+{
+	NetworkClientInfo *ci;
+	
+	if (argc != 3 && argc != 2) {
+		IConsoleHelp("Mute a specific client. Usage: 'mute <clientid> <mutetype>'");
+		IConsoleHelp("Types are 1.broadcast 2.team and 3.private");
+		return true;
+	}
+	uint16 client_index = atoi(argv[1]);
+	
+	ci = NetworkFindClientInfoFromIndex(client_index);
+	if (ci == NULL) {
+		IConsoleError("Invalid client");
+		return true;
+	}
+	
+	if (client_index == NETWORK_SERVER_INDEX) {
+		IConsoleError("Silly boy, you can not mute the server");
+		return true;
+	}
+
+	if (argc == 3) {
+		switch (atoi(argv[2]) - 1) {
+			case DESTTYPE_BROADCAST:
+				ToggleBit(ci->mute, 1);
+				break;
+			case DESTTYPE_TEAM:
+				ToggleBit(ci->mute, 2);
+				break;
+			case DESTTYPE_CLIENT:
+				ToggleBit(ci->mute, 3);
+				break;
+			default: return false;
+		}
+	}
+	IConsolePrintF(CC_DEFAULT, "Current muted status of client %d: %s %s %s", client_index, (HasBit(ci->mute, 1) ? "public" : ""), (HasBit(ci->mute, 2) ? "team" : ""), (HasBit(ci->mute, 3) ? "private" : ""));
+	NetworkServerSendMuteStatus(client_index);
+	if (!_network_dedicated) InvalidateWindow(WC_MUTE_PLAYER, 0);
+	return true;
+	
+}
+
 #endif /* ENABLE_NETWORK */
 
 /* ******************************** */
@@ -1358,6 +1455,7 @@
 	IConsoleCmdRegister("getdate",      ConGetDate);
 	IConsoleCmdRegister("quit",         ConExit);
 	IConsoleCmdRegister("resetengines", ConResetEngines);
+	IConsoleCmdRegister("reseteconomy", ConResetEconomy);
 	IConsoleCmdRegister("return",       ConReturn);
 	IConsoleCmdRegister("screenshot",   ConScreenShot);
 	IConsoleCmdRegister("script",       ConScript);
@@ -1412,6 +1510,8 @@
 	IConsoleCmdRegister("rcon",            ConRcon);
 	IConsoleCmdHookAdd("rcon",             ICONSOLE_HOOK_ACCESS, ConHookNeedNetwork);
 
+	IConsoleCmdRegister("move",            ConMoveClient);
+	IConsoleCmdHookAdd("move",             ICONSOLE_HOOK_ACCESS, ConHookServerOnly);
 	IConsoleCmdRegister("reset_company",   ConResetCompany);
 	IConsoleCmdHookAdd("reset_company",    ICONSOLE_HOOK_ACCESS, ConHookServerOnly);
 	IConsoleAliasRegister("clean_company", "reset_company %A");
@@ -1428,6 +1528,8 @@
 	IConsoleCmdHookAdd("pause",            ICONSOLE_HOOK_ACCESS, ConHookServerOnly);
 	IConsoleCmdRegister("unpause",         ConUnPauseGame);
 	IConsoleCmdHookAdd("unpause",          ICONSOLE_HOOK_ACCESS, ConHookServerOnly);
+	IConsoleCmdRegister("mute",         ConMute);
+	IConsoleCmdHookAdd("mute",          ICONSOLE_HOOK_ACCESS, ConHookServerOnly);
 
 	/*** Networking variables ***/
 	IConsoleVarStringRegister("company_pw",      NULL, 0, "Set a password for your company, so no one without the correct password can join. Use '*' to clear the password");
Index: src/npf.cpp
===================================================================
--- src/npf.cpp	(revision 13683)
+++ src/npf.cpp	(working copy)
@@ -24,6 +24,7 @@
 #include "vehicle_base.h"
 #include "settings_type.h"
 #include "tunnelbridge.h"
+#include "sharedinfrastructure.h"
 
 static AyStar _npf_aystar;
 
@@ -465,25 +466,37 @@
  */
 static bool CanEnterTileOwnerCheck(Owner owner, TileIndex tile, DiagDirection enterdir)
 {
-	if (IsTileType(tile, MP_RAILWAY) ||             /* Rail tile (also rail depot) */
-			IsRailwayStationTile(tile) ||   /* Rail station tile */
-			IsRoadDepotTile(tile) ||        /* Road depot tile */
-			IsStandardRoadStopTile(tile)) { /* Road station tile (but not drive-through stops) */
-		return IsTileOwner(tile, owner); /* You need to own these tiles entirely to use them */
-	}
+	unsigned char tileOwner = IsTileOwner(tile,owner);
+	if(IsTileType(tile, MP_RAILWAY) && !IsRailwayStation(tile))
+		return ( tileOwner || SharedTracks(tile,owner));
 
+	if (IsRailwayStation(tile))
+	  	return ( tileOwner || SharedRailwayStations(tile,owner));
+
+	if (IsDepotTypeTile(tile, TRANSPORT_RAIL))
+		return ( tileOwner || SharedRailwayDepots(tile,owner));
+
+	if (IsDepotTypeTile(tile, TRANSPORT_ROAD))
+		return ( tileOwner || SharedRoadDepots(tile,owner));
+
+	if (IsStandardRoadStopTile(tile))
+		return ( tileOwner || SharedRoadStops(tile,owner));
+
+	if (IsDepotTypeTile(tile, TRANSPORT_WATER))
+		return ( tileOwner || SharedWaterDepots(tile,owner));
+
 	switch (GetTileType(tile)) {
 		case MP_ROAD:
 			/* rail-road crossing : are we looking at the railway part? */
 			if (IsLevelCrossing(tile) &&
 					DiagDirToAxis(enterdir) != GetCrossingRoadAxis(tile)) {
-				return IsTileOwner(tile, owner); /* Railway needs owner check, while the street is public */
+ 				return (tileOwner || SharedTracks(tile,owner)); /* Railway needs owner check, while the street is public */
 			}
 			break;
 
 		case MP_TUNNELBRIDGE:
 			if (GetTunnelBridgeTransportType(tile) == TRANSPORT_RAIL) {
-				return IsTileOwner(tile, owner);
+ 				return (tileOwner || SharedTracks(tile,owner));
 			}
 			break;
 
@@ -880,7 +893,7 @@
 	FOR_ALL_DEPOTS(depot) {
 		/* Check if this is really a valid depot, it is of the needed type and
 		 * owner */
-		if (IsDepotTypeTile(depot->xy, type) && IsTileOwner(depot->xy, owner))
+		if (IsDepotTypeTile(depot->xy, type) && ((IsTileOwner(depot->xy, owner)||SharedDepotTransport(depot->xy,owner,type))))
 			/* If so, let's add it to the queue, sorted by distance */
 			depots.push(&depots, depot, DistanceManhattan(tile, depot->xy));
 	}
Index: src/terraform_cmd.cpp
===================================================================
--- src/terraform_cmd.cpp	(revision 13683)
+++ src/terraform_cmd.cpp	(working copy)
@@ -12,6 +12,7 @@
 #include "variables.h"
 #include "functions.h"
 #include "economy_func.h"
+#include "settings_type.h"
 
 #include "table/strings.h"
 
@@ -206,9 +207,13 @@
 			if (abs(height_diff) > 1) {
 				/* Terraform the neighboured corner. The resulting height difference should be 1. */
 				height_diff += (height_diff < 0 ? 1 : -1);
-				CommandCost cost = TerraformTileHeight(ts, tile, r + height_diff);
-				if (CmdFailed(cost)) return cost;
-				total_cost.AddCost(cost);
+				if (_settings_game.construction.one_tile_terraform) {
+					return CMD_ERROR;
+				} else {
+					CommandCost cost = TerraformTileHeight(ts, tile, r + height_diff);
+					if (CmdFailed(cost)) return cost;
+					total_cost.AddCost(cost);
+				}
 			}
 		}
 	}
@@ -301,10 +306,7 @@
 				return_cmd_error(STR_1002_EXCAVATION_WOULD_DAMAGE);
 			}
 			/* Check tiletype-specific things, and add extra-cost */
-			const bool curr_gen = _generating_world;
-			if (_game_mode == GM_EDITOR) _generating_world = true; // used to create green terraformed land
 			CommandCost cost = _tile_type_procs[GetTileType(tile)]->terraform_tile_proc(tile, flags | DC_AUTO, z_min * TILE_HEIGHT, tileh);
-			_generating_world = curr_gen;
 			if (CmdFailed(cost)) {
 				_terraform_err_tile = tile;
 				return cost;
@@ -371,6 +373,9 @@
 
 	int size_x = ex - sx + 1;
 	int size_y = ey - sy + 1;
+	
+	/* make sure that the terraform region is not larger than 2x2, if one-tile terraform enabled */
+	if ((size_x > 2 || size_y > 2) && _settings_game.construction.one_tile_terraform) { return CMD_ERROR; }
 
 	Money money = GetAvailableMoneyForCommand();
 	CommandCost cost(EXPENSES_CONSTRUCTION);
Index: src/saveload.cpp
===================================================================
--- src/saveload.cpp	(revision 13683)
+++ src/saveload.cpp	(working copy)
@@ -36,7 +36,7 @@
 
 #include "table/strings.h"
 
-extern const uint16 SAVEGAME_VERSION = 98;
+extern const uint16 SAVEGAME_VERSION = SL_VERSION_PATCH;
 
 SavegameType _savegame_type; ///< type of savegame we are loading
 
Index: src/misc_gui.cpp
===================================================================
--- src/misc_gui.cpp	(revision 13683)
+++ src/misc_gui.cpp	(working copy)
@@ -72,7 +72,7 @@
 
 class LandInfoWindow : public Window {
 	enum {
-		LAND_INFO_CENTERED_LINES   = 9,                        ///< Up to 9 centered lines
+		LAND_INFO_CENTERED_LINES   = 11,                       ///< Up to 11 centered lines
 		LAND_INFO_MULTICENTER_LINE = LAND_INFO_CENTERED_LINES, ///< One multicenter line
 		LAND_INFO_LINE_END,
 
@@ -127,6 +127,9 @@
 		td.owner[2] = OWNER_NONE;
 		td.owner[3] = OWNER_NONE;
 
+		td.grfclass = STR_NULL;
+		td.grfname = STR_NULL;
+
 		GetAcceptedCargo(tile, ac);
 		GetTileDesc(tile, &td);
 
@@ -181,6 +184,18 @@
 			line_nr++;
 		}
 
+		if (td.grfclass != STR_NULL) {
+			SetDParam(0, td.grfclass);
+			GetString(this->landinfo_data[line_nr], STR_TILEDESC_STATION_CLASS, lastof(this->landinfo_data[line_nr]));
+			line_nr++;
+		}
+
+		if (td.grfname != STR_NULL) {
+			SetDParam(0, td.grfname);
+			GetString(this->landinfo_data[line_nr], STR_TILEDESC_STATION_TYPE, lastof(this->landinfo_data[line_nr]));
+			line_nr++;
+		}
+
 		/* Mark last line empty */
 		this->landinfo_data[line_nr][0] = '\0';
 
Index: src/rail_cmd.cpp
===================================================================
--- src/rail_cmd.cpp	(revision 13683)
+++ src/rail_cmd.cpp	(working copy)
@@ -296,7 +296,7 @@
 	   ) return_cmd_error(STR_1000_LAND_SLOPED_IN_WRONG_DIRECTION);
 
 	Foundation f_old = GetRailFoundation(tileh, existing);
-	return CommandCost(EXPENSES_CONSTRUCTION, f_new != f_old ? _price.terraform : (Money)0);
+	return CommandCost(EXPENSES_CONSTRUCTION, f_new != f_old ? (_price.build_rail <<3) : (Money)0);
 }
 
 /* Validate functions for rail building */
@@ -2286,7 +2286,16 @@
 	byte fract_coord_leave;
 	DiagDirection dir;
 	int length;
+	Owner trackowner;
 
+	/* Account for use of shared tracks */
+	if (v->tile != tile && IsFrontEngine(v)) {
+		trackowner = GetTileOwner(tile);
+		if (trackowner != v->owner) {
+			v->shared_tontiles[trackowner] += v->u.rail.cached_weight;
+		}
+	}
+
 	/* this routine applies only to trains in depot tiles */
 	if (v->type != VEH_TRAIN || !IsRailDepotTile(tile)) return VETSB_CONTINUE;
 
@@ -2363,7 +2372,7 @@
 		case TRACK_BIT_UPPER: track_corner = CORNER_N; break;
 
 		/* Surface slope must not be changed */
-		default: return (((z_old != z_new) || (tileh_old != tileh_new)) ? CMD_ERROR : CommandCost(EXPENSES_CONSTRUCTION, _price.terraform));
+		default: return (((z_old != z_new) || (tileh_old != tileh_new)) ? CMD_ERROR : CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3)));
 	}
 
 	/* The height of the track_corner must not be changed. The rest ensures GetRailFoundation() already. */
@@ -2371,7 +2380,7 @@
 	z_new += GetSlopeZInCorner(RemoveHalftileSlope(tileh_new), track_corner);
 	if (z_old != z_new) return CMD_ERROR;
 
-	CommandCost cost = CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+	CommandCost cost = CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 	/* Make the ground dirty, if surface slope has changed */
 	if (tileh_old != tileh_new) {
 		/* If there is flat water on the lower halftile add the cost for clearing it */
@@ -2431,7 +2440,7 @@
 				}
 
 				case RAIL_TILE_DEPOT:
-					if (AutoslopeCheckForEntranceEdge(tile, z_new, tileh_new, GetRailDepotDirection(tile))) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+					if (AutoslopeCheckForEntranceEdge(tile, z_new, tileh_new, GetRailDepotDirection(tile))) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 					break;
 
 				default: NOT_REACHED();
Index: src/smallmap_gui.cpp
===================================================================
--- src/smallmap_gui.cpp	(revision 13683)
+++ src/smallmap_gui.cpp	(working copy)
@@ -1230,7 +1230,7 @@
 	_extra_view_port_widgets,
 };
 
-void ShowExtraViewPortWindow(TileIndex tile)
+int ShowExtraViewPortWindow(TileIndex tile)
 {
 	int i = 0;
 
@@ -1238,6 +1238,8 @@
 	while (FindWindowById(WC_EXTRA_VIEW_PORT, i) != NULL) i++;
 
 	new ExtraViewportWindow(&_extra_view_port_desc, i, tile);
+
+	return i;
 }
 
 bool ScrollMainWindowTo(int x, int y, bool instant)
Index: src/date.cpp
===================================================================
--- src/date.cpp	(revision 13683)
+++ src/date.cpp	(working copy)
@@ -170,6 +170,8 @@
 extern void TownsMonthlyLoop();
 extern void IndustryMonthlyLoop();
 extern void StationMonthlyLoop();
+extern void SharedTracksPayment();
+extern void SharedSettingDelay();
 
 extern void PlayersYearlyLoop();
 extern void TrainsYearlyLoop();
@@ -265,6 +267,9 @@
 #ifdef ENABLE_NETWORK
 		if (_network_server) NetworkServerMonthlyLoop();
 #endif /* ENABLE_NETWORK */
+ 		SharedTracksPayment();
+ 		SharedSettingDelay();
+
 	}
 
 	/* check if we entered a new year? */
